diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/channel.c ircd-hybrid-6.0/src/channel.c
--- ircd-hybrid-6.0.orig/src/channel.c	Mon May 21 21:27:53 2001
+++ ircd-hybrid-6.0/src/channel.c	Mon May 21 21:26:26 2001
@@ -2834,7 +2834,7 @@
            * -Dianora
            */
           server_was_split = NO;
-          sendto_ops("Net Rejoined, split-mode deactivated");
+          sendto_ops_flags(FLAGS_SERVNOTICE, "Net rejoined, split-mode deactivated, whew");
           cold_start = NO;
 #if defined(PRESERVE_CHANNEL_ON_SPLIT) || defined(NO_JOIN_ON_SPLIT)
           remove_empty_channels();
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/client.c ircd-hybrid-6.0/src/client.c
--- ircd-hybrid-6.0.orig/src/client.c	Sun Dec 31 00:11:59 2000
+++ ircd-hybrid-6.0/src/client.c	Mon May 21 21:26:25 2001
@@ -672,7 +672,7 @@
         {
           if (!server_was_split)
             {
-              sendto_ops("Netsplit detected, split-mode activated");
+              sendto_ops_flags(FLAGS_SERVNOTICE, "Netsplit detected, split-mode activated, hope for the best");
               server_was_split = YES;
             }
           server_split_time = CurrentTime;
@@ -1584,7 +1584,7 @@
 #ifdef SERVERHIDE
       strcpy(comment1, me.name);
       strcat(comment1, " ");
-      strcat(comment1, me.name);
+      strcat(comment1, NETWORK_NAME);
 #else 
       /* I'm paranoid -Dianora */
       if((sptr->serv) && (sptr->serv->up))
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_oper.c ircd-hybrid-6.0/src/m_oper.c
--- ircd-hybrid-6.0.orig/src/m_oper.c	Fri Dec  1 06:28:49 2000
+++ ircd-hybrid-6.0/src/m_oper.c	Mon May 21 21:26:25 2001
@@ -231,7 +231,7 @@
 
       fdlist_add(sptr->fd, FDL_OPER | FDL_BUSY);
 #ifdef CUSTOM_ERR
-      sendto_ops("%s (%s@%s) has just acquired the personality of a petty megalomaniacal tyrant [IRC(%c)p]", parv[0],
+      sendto_ops("%s (%s@%s) just activated an %c-line, hmmm.", parv[0],
 #else
       sendto_ops("%s (%s@%s) is now operator (%c)", parv[0],
 #endif /* CUSTOM_ERR */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_rehash.c ircd-hybrid-6.0/src/m_rehash.c
--- ircd-hybrid-6.0.orig/src/m_rehash.c	Fri Dec 22 02:28:11 2000
+++ ircd-hybrid-6.0/src/m_rehash.c	Mon May 21 21:26:25 2001
@@ -215,9 +215,9 @@
 #undef OUT
 
 #ifdef GLINES
-#define OUT "rehash one of :DNS TKLINES GLINES GC HELP MOTD OMOTD DUMP"
+#define OUT "rehash one of :DNS DLINES TKLINES GLINES GC HELP MOTD OMOTD DUMP"
 #else
-#define OUT "rehash one of :DNS TKLINES GC HELP MOTD OMOTD DUMP"
+#define OUT "rehash one of :DNS DLINES TKLINES GC HELP MOTD OMOTD DUMP"
 #endif
           sendto_one(sptr, ":%s NOTICE %s :%s", me.name, sptr->name, OUT);
           return(0);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_set.c ircd-hybrid-6.0/src/m_set.c
--- ircd-hybrid-6.0.orig/src/m_set.c	Mon May 21 21:27:53 2001
+++ ircd-hybrid-6.0/src/m_set.c	Mon May 21 21:26:26 2001
@@ -444,7 +444,7 @@
                       if (server_was_split)
                         {
                           server_was_split = NO;
-                          sendto_ops("split-mode deactived by manual override");
+                          sendto_ops_flags(FLAGS_SERVNOTICE, "split-mode deactived by manual override");
                         }
 #if defined(PRESERVE_CHANNEL_ON_SPLIT) || defined(NO_JOIN_ON_SPLIT)
                       remove_empty_channels();
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/messages_cust.tab ircd-hybrid-6.0/src/messages_cust.tab
--- ircd-hybrid-6.0.orig/src/messages_cust.tab	Sun Dec 31 00:12:01 2000
+++ ircd-hybrid-6.0/src/messages_cust.tab	Mon May 21 21:26:25 2001
@@ -27,7 +27,7 @@
 /* 000 */       (char *)NULL,
 /* 001  RPL_WELCOME, */ ":%s 001 %s :Welcome to the Internet Relay Network %s",
 /* 002  RPL_YOURHOST,*/ ":%s 002 %s :Your host is %s, running version %s",
-/* 003  RPL_CREATED, */ ":%s 003 %s :This server was created %s",
+/* 003  RPL_CREATED, */ ":%s 003 %s :This server was cobbled together %s",
 /* 004  RPL_MYINFO, */ ":%s 004 %s %s %s oiwszcrkfydnxb biklmnopstved",
 /* 005 */       (char *)NULL,
 /* 006 */       (char *)NULL,
@@ -266,7 +266,7 @@
 /* 239 */       (char *)NULL,
 /* 240 */       (char *)NULL,
 /* 241 RPL_STATSLLINE, */       ":%s 241 %s %c %s * %s %d %d",
-/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Dianora hasn't messed with the server code now in %d days, %d:%02d:%02d",
+/* 242 RPL_STATSUPTIME,*/       ":%s 242 %s :Server up %d days, %d:%02d:%02d since Dianora messed with the code",
 /* 243 RPL_STATSOLINE, */       ":%s 243 %s %c %s@%s * %s %s %d %s",
 /* 244 RPL_STATSHLINE, */       ":%s 244 %s %c %s * %s %d %d", 
 /* 245 RPL_STATSSLINE, */       ":%s 245 %s %c %s * %s %d %d", 
@@ -278,8 +278,8 @@
 /* 250 RPL_STATSCONN, */
                     ":%s 250 %s :Highest connection count: %d (%d clients) (%d since server was (re)started)",
 /* 251 RPL_LUSERCLIENT, */
-                ":%s 251 %s :There are %d users and %d invisible on %d servers",
-/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :Smurf Targets (IRC Operators) online",
+                ":%s 251 %s :There are %d victims and %d invisible on %d servers",
+/* 252 RPL_LUSEROP, */          ":%s 252 %s %d :minor deities online",
 /* 253 RPL_LUSERUNKNOWN, */     ":%s 253 %s %d :unknown connection(s)",
 /* 254 RPL_LUSERCHANNELS, */    ":%s 254 %s %d :channels formed",
 /* 255 RPL_LUSERME, */          ":%s 255 %s :I have %d clients and %d servers",
@@ -291,7 +291,7 @@
 /* 261 RPL_TRACELOG, */         ":%s 261 %s File %s %d",
 /* 262 RPL_ENDOFTRACE, */       ":%s 262 %s %s :End of TRACE",
 /* 263 RPL_LOAD2HI, */
-":%s 263 %s :Hold your horses... the server load is temporarily too heavy. Try again later, ok?",
+":%s 263 %s :server load is temporarily too heavy, please try again later?",
 /* 264 */       (char *)NULL,
 /* 265 RPL_LOCALUSERS, */       ":%s 265 %s :Current local  users: %d  Max: %d",
 /* 266 RPL_GLOBALUSERS, */      ":%s 266 %s :Current global users: %d  Max: %d",
@@ -333,15 +333,15 @@
 /* 302 RPL_USERHOST, */  ":%s 302 %s :%s",
 /* 303 RPL_ISON, */     ":%s 303 %s :",
 /* 304 RPL_TEXT, */      (char *)NULL,
-/* 305 RPL_UNAWAY, */   ":%s 305 %s :OK, you're not /away anymore. Did you have fun?",
-/* 306 RPL_NOWAWAY, */  ":%s 306 %s :OK, you're /away now. Hurry back!",
+/* 305 RPL_UNAWAY, */   ":%s 305 %s :Does this mean you're really back?",
+/* 306 RPL_NOWAWAY, */  ":%s 306 %s :We'll miss you",
 /* 307 */       (char *)NULL,
 /* 308 */       (char *)NULL,
 /* 309 */       (char *)NULL,
 /* 310 */       (char *)NULL,
 /* 311 RPL_WHOISUSER, */        ":%s 311 %s %s %s %s * :%s",
 /* 312 RPL_WHOISSERVER, */      ":%s 312 %s %s %s :%s",
-/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is a Smurf Target (IRC Operator)",
+/* 313 RPL_WHOISOPERATOR, */    ":%s 313 %s %s :is a deity of the small screen",
 /* 314 RPL_WHOWASUSER, */       ":%s 314 %s %s %s %s * :%s",
 /* 315 RPL_ENDOFWHO, */         ":%s 315 %s %s :End of /WHO list.",
 /* 316 RPL_WHOISCHANOP, */      (char *)NULL,
@@ -359,7 +359,7 @@
 /* 328 */       (char *)NULL,
 /* 329 RPL_CREATIONTIME, */      ":%s 329 %s %s %lu", 
 /* 330 */       (char *)NULL,
-/* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :No topic is set.",
+/* 331 RPL_NOTOPIC, */          ":%s 331 %s %s :There isn't a topic.",
 /* 332 RPL_TOPIC, */            ":%s 332 %s %s :%s",
 #ifdef TOPIC_INFO
 /* 333 RPL_TOPICWHOTIME, */     ":%s 333 %s %s %s %lu",
@@ -421,8 +421,8 @@
 /* 378 */       (char *)NULL,
 /* 379 */       (char *)NULL,
 /* 380 */       (char *)NULL,
-/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You are now one bad motherfucker - Go /kill someone.",
-/* 382 RPL_REHASHING, */        ":%s 382 %s %s :it slices, dices, and even reloads config files! Rehashing config file, mang.",
+/* 381 RPL_YOUREOPER, */        ":%s 381 %s :You are now a deity -- be nice or else!",
+/* 382 RPL_REHASHING, */        ":%s 382 %s %s :Rehashing the server configuration file, dear.",
 /* 383 */       (char *)NULL,
 /* 384 RPL_MYPORTIS, */         ":%s 384 %s %d :Port to local server is\r\n",
 /* 385 RPL_NOTOPERANYMORE, */   (char *)NULL,
@@ -442,10 +442,10 @@
 /* 399 */       (char *)NULL,
 /* 400 */       (char *)NULL,
 /* 401 ERR_NOSUCHNICK, */       ":%s 401 %s %s :No such nick/channel",
-/* 402 ERR_NOSUCHSERVER, */     ":%s 402 %s %s :No such server",
-/* 403 ERR_NOSUCHCHANNEL, */    ":%s 403 %s %s :No such channel",
-/* 404 ERR_CANNOTSENDTOCHAN, */ ":%s 404 %s %s :Cannot send to channel",
-/* 405 ERR_TOOMANYCHANNELS, */  ":%s 405 %s %s :You have joined too many channels",
+/* 402 ERR_NOSUCHSERVER, */     ":%s 402 %s %s :That server doesn't exist",
+/* 403 ERR_NOSUCHCHANNEL, */    ":%s 403 %s %s :That channel doesn't exist",
+/* 404 ERR_CANNOTSENDTOCHAN, */ ":%s 404 %s %s :The channel demigods have stolen your voice",
+/* 405 ERR_TOOMANYCHANNELS, */  ":%s 405 %s %s :You can't join that many channels",
 /* 406 ERR_WASNOSUCHNICK, */    ":%s 406 %s %s :There was no such nickname",
 /* 407 ERR_TOOMANYTARGETS, */
                 ":%s 407 %s %s :Too many recipients. Only %d processed",
@@ -455,7 +455,7 @@
 /* 411 ERR_NORECIPIENT, */      ":%s 411 %s :No recipient given (%s)",
 /* 412 ERR_NOTEXTTOSEND, */     ":%s 412 %s :No text to send",
 /* 413 ERR_NOTOPLEVEL, */       ":%s 413 %s %s :No toplevel domain specified",
-/* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel Domain",
+/* 414 ERR_WILDTOPLEVEL, */     ":%s 414 %s %s :Wildcard in toplevel domain!",
 /* 415 */       (char *)NULL,
 /* 416 */       (char *)NULL,
 /* 417 */       (char *)NULL,
@@ -474,7 +474,7 @@
 /* 429 */       (char *)NULL,
 /* 430 */       (char *)NULL,
 /* 431 ERR_NONICKNAMEGIVEN, */  ":%s 431 %s :No nickname given",
-/* 432 ERR_ERRONEUSNICKNAME, */ ":%s 432 %s %s :Erroneus Nickname",
+/* 432 ERR_ERRONEUSNICKNAME, */ ":%s 432 %s %s :Erroneous Nickname",
 /* 433 ERR_NICKNAMEINUSE, */    ":%s 433 %s %s :Nickname is already in use.",
 /* 434 */       (char *)NULL,
 /* 435 */       (char *)NULL,
@@ -493,7 +493,7 @@
 /* 448 */       (char *)NULL,
 /* 449 */       (char *)NULL,
 /* 450 */       (char *)NULL,
-/* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You have not registered",
+/* 451 ERR_NOTREGISTERED, */    ":%s 451 %s :You haven't registered yet",
 /* 452 */       (char *)NULL,
 /* 453 */       (char *)NULL,
 /* 454 */       (char *)NULL,
@@ -504,29 +504,29 @@
 /* 459 */       (char *)NULL,
 /* 460 */       (char *)NULL,
 /* 461 ERR_NEEDMOREPARAMS, */   ":%s 461 %s %s :Not enough parameters",
-/* 462 ERR_ALREADYREGISTRED, */ ":%s 462 %s :You may not reregister",
+/* 462 ERR_ALREADYREGISTRED, */ ":%s 462 %s :Please register only once per session",
 /* 463 ERR_NOPERMFORHOST, */    ":%s 463 %s :Your host isn't among the privileged",
-/* 464 ERR_PASSWDMISMATCH, */   ":%s 464 %s :BZZT!! Wrong password, homez. Are you sure you know what you're doing??",
-/* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You are banned from this server- %s",
+/* 464 ERR_PASSWDMISMATCH, */   ":%s 464 %s :Hmmm, that wasn't the right password",
+/* 465 ERR_YOUREBANNEDCREEP, */ ":%s 465 %s :You may not connect to this server- %s",
 /* 466 ERR_YOUWILLBEBANNED, */  (char *)NULL,
-/* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key already set",
+/* 467 ERR_KEYSET, */           ":%s 467 %s %s :Channel key is already set",
 /* 468 */       (char *)NULL,
 /* 469 */       (char *)NULL,
 /* 470 */       (char *)NULL,
-/* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Cannot join channel (+l)",
+/* 471 ERR_CHANNELISFULL, */    ":%s 471 %s %s :Channel is already full (+l)",
 /* 472 ERR_UNKNOWNMODE  , */    ":%s 472 %s %c :is unknown mode char to me",
-/* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :Cannot join channel (+i)",
-/* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :Cannot join channel (+b)",
-/* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :Cannot join channel (+k)",
+/* 473 ERR_INVITEONLYCHAN, */   ":%s 473 %s %s :You need to be invited to that channel",
+/* 474 ERR_BANNEDFROMCHAN, */   ":%s 474 %s %s :You're banned from that channel",
+/* 475 ERR_BADCHANNELKEY, */    ":%s 475 %s %s :You must specify the channel key (+k)",
 /* 476 ERR_BADCHANMASK, */      ":%s 476 %s %s :Bad Channel Mask",
 /* 477 ERR_MODELESS, */         ":%s 477 %s %s :Channel does not support modes",
 /* 478 ERR_BANLISTFULL, */      ":%s 478 %s %s %s :Channel ban list is full",
 /* 479 ERR_BADCHANNAME */       ":%s 479 %s %s :Illegal channel name",
 /* 480 */	(char *)NULL,
 /* 481 ERR_NOPRIVILEGES, */
-                ":%s 481 %s :I don't THINK so, homez... you ain't got what it takes. (IRC operator)",
-/* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You can't do that thing, when you don't have that swing (You're not channel operator)",
-/* 483 ERR_CANTKILLSERVER, */    ":%s 483 %s :Don't be an idiot - you can't kill a SERVER, fool.",
+                ":%s 481 %s :Permission Denied - You're no deity",
+/* 482 ERR_CHANOPRIVSNEEDED, */ ":%s 482 %s %s :You need to be an operator to do that",
+/* 483 ERR_CANTKILLSERVER, */    ":%s 483 %s :You can't actually kill an IRC server that way.",
 /* 484 */       (char *)NULL,
 /* 485 */       (char *)NULL,
 /* 486 */       (char *)NULL,
@@ -534,7 +534,7 @@
 /* 488 */       (char *)NULL,
 /* 489 */       (char *)NULL,
 /* 490 */       (char *)NULL,
-/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :Sorry, you just don't have what it takes to be an IRC Operator here.",
+/* 491 ERR_NOOPERHOST, */       ":%s 491 %s :You don't have an O-line for the host you're on.",
 /* 492 */       (char *)NULL,
 /* 493 */       (char *)NULL,
 /* 494 */       (char *)NULL,
@@ -545,7 +545,7 @@
 /* 499 */       (char *)NULL,
 /* 500 */       (char *)NULL,
 /* 501 ERR_UMODEUNKNOWNFLAG, */ ":%s 501 %s :Unknown MODE flag",
-/* 502 ERR_USERSDONTMATCH, */   ":%s 502 %s :Can't change mode for other users",
+/* 502 ERR_USERSDONTMATCH, */   ":%s 502 %s :You can't change someone else's modes",
 /* 503 ERR_GHOSTEDCLIENT, */    ":%s 503 %s :Message could not be delivered to %s",
 /* 504 LAST ERR_LAST_ERR_MSG, */        ":%s 504 %s :Last Error Message",
                 (char *)NULL
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_auth.c ircd-hybrid-6.0/src/s_auth.c
--- ircd-hybrid-6.0.orig/src/s_auth.c	Tue Oct 17 07:20:51 2000
+++ ircd-hybrid-6.0/src/s_auth.c	Mon May 21 21:26:25 2001
@@ -63,13 +63,13 @@
   /* 123456789012345678901234567890123456789012345678901234567890 */
   { "NOTICE AUTH :*** Looking up your hostname...\r\n",    46 },
   { "NOTICE AUTH :*** Found your hostname\r\n",            38 },
-  { "NOTICE AUTH :*** Found your hostname, cached\r\n",    46 },
+  { "NOTICE AUTH :*** Found your hostname, welcome back\r\n", 52 },
   { "NOTICE AUTH :*** Couldn't look up your hostname\r\n", 49 },
   { "NOTICE AUTH :*** Checking Ident\r\n",                 33 },
   { "NOTICE AUTH :*** Got Ident response\r\n",             37 },
-  { "NOTICE AUTH :*** No Ident response\r\n",              36 },
-  { "NOTICE AUTH :*** Your forward and reverse DNS do not match, " \
-    "ignoring hostname.\r\n",                              80 }
+  { "NOTICE AUTH :*** No identd (auth) response, kind of weird.\r\n", 60 },
+  { "NOTICE AUTH :*** Your forward and reverse DNS don't match, bad sign." \
+    "\r\n",                                                70 }
 };
 
 typedef enum {
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/s_user.c ircd-hybrid-6.0/src/s_user.c
--- ircd-hybrid-6.0.orig/src/s_user.c	Mon May 21 21:27:52 2001
+++ ircd-hybrid-6.0/src/s_user.c	Mon May 21 21:26:26 2001
@@ -562,6 +562,7 @@
 
   if (MyConnect(sptr))
     {
+      if (!strcmp(sptr->host, "localhost")) strcpy(sptr->host, me.name);
       switch( check_client(sptr,username,&reason))
         {
         case SOCKET_ERROR:
@@ -650,8 +651,8 @@
 
       if(!valid_hostname(sptr->host))
         {
-          sendto_one(sptr,":%s NOTICE %s :*** Notice -- You have an illegal character in your hostname", 
-                     me.name, sptr->name );
+          sendto_one(sptr,":%s NOTICE %s :*** Notice -- hostname %s isn't valid, using default",
+                     me.name, sptr->name, sptr->host );
 
           strncpy(sptr->host,sptr->sockhost,HOSTIPLEN+1);
         }
@@ -842,12 +843,12 @@
       show_lusers(sptr, sptr, 1, parv);
 
 #ifdef SHORT_MOTD
-      sendto_one(sptr,"NOTICE %s :*** Notice -- motd was last changed at %s",
+      sendto_one(sptr,"NOTICE %s :*** Notice -- MOTD was last changed at %s",
                  sptr->name,
                  ConfigFileEntry.motd.lastChangedDate);
 
       sendto_one(sptr,
-                 "NOTICE %s :*** Notice -- Please read the motd if you haven't read it",
+                 "NOTICE %s :*** Notice -- If you haven't read the MOTD, please do (/motd command)",
                  sptr->name);
       
       sendto_one(sptr, form_str(RPL_MOTDSTART),
@@ -879,7 +880,7 @@
 #ifdef NEED_SPLITCODE
       if (server_was_split)
         {
-          sendto_one(sptr,"NOTICE %s :*** Notice -- server is currently in split-mode",nick);
+          sendto_one(sptr,"NOTICE %s :*** Notice -- Server is currently split, channel modes are limited",nick);
         }
 
       nextping = CurrentTime;