diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/Makefile.in ircd-hybrid-6.0/Makefile.in
--- ircd-hybrid-6.0.orig/Makefile.in	Fri Oct  6 04:00:46 2000
+++ ircd-hybrid-6.0/Makefile.in	Fri May 25 20:59:26 2001
@@ -22,7 +22,7 @@
 RM=@RM@
 
 # Default CFLAGS
-CFLAGS = -g -O2 -DNDEBUG
+CFLAGS = -g3 -Wall -O2 -DNDEBUG
 
 # Default make flags - you may want to uncomment this on a multicpu machine
 #MFLAGS = -j 4
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/autoconf/configure.in ircd-hybrid-6.0/autoconf/configure.in
--- ircd-hybrid-6.0.orig/autoconf/configure.in	Fri Oct  6 04:00:51 2000
+++ ircd-hybrid-6.0/autoconf/configure.in	Fri May 25 20:59:26 2001
@@ -39,6 +39,9 @@
 dnl check for poll() call
 AC_CHECK_FUNC(poll, AC_DEFINE(USE_POLL),)
 
+dnl check for u_int32_t
+AC_CHECK_TYPE(u_int32_t, unsigned long)
+
 dnl taken from ircd's Config script
 AC_MSG_CHECKING(for non-blocking socket implementation)
 AC_TRY_RUN(
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/client.h ircd-hybrid-6.0/include/client.h
--- ircd-hybrid-6.0.orig/include/client.h	Fri May 25 21:09:31 2001
+++ ircd-hybrid-6.0/include/client.h	Fri May 25 20:59:29 2001
@@ -139,9 +139,9 @@
   time_t            firsttime;  /* time client was created */
   time_t            since;      /* last time we parsed something */
   time_t            tsinfo;     /* TS on the nick, SVINFO on server */
-  unsigned int      umodes;     /* opers, normal users subset */
-  unsigned int      flags;      /* client flags */
-  unsigned int      flags2;     /* ugh. overflow */
+  u_int32_t         umodes;     /* opers, normal users subset */
+  u_int32_t         flags;      /* client flags */
+  u_int32_t         flags2;     /* ugh. overflow */
   int               fd;         /* >= 0, for local clients */
   int               hopcount;   /* number of servers to this 0 = local */
   unsigned short    status;     /* Client type */
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/setup.h.in ircd-hybrid-6.0/include/setup.h.in
--- ircd-hybrid-6.0.orig/include/setup.h.in	Fri Oct  6 04:00:57 2000
+++ ircd-hybrid-6.0/include/setup.h.in	Fri May 25 20:59:26 2001
@@ -70,3 +70,6 @@
 
 /* Define if you have the socket library (-lsocket).  */
 #undef HAVE_LIBSOCKET
+
+/* Define if you don't have u_int32_t. */
+#undef u_int32_t
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/tools/install_ircd ircd-hybrid-6.0/tools/install_ircd
--- ircd-hybrid-6.0.orig/tools/install_ircd	Fri Oct  6 04:01:02 2000
+++ ircd-hybrid-6.0/tools/install_ircd	Fri May 25 20:59:26 2001
@@ -125,25 +125,25 @@
 fi
 
 # install mkpasswd
-if [ ! -f ${DPATH}/mkpasswd ]; then
-  echo installing mkpasswd as ${DPATH}/mkpasswd${EXESUFFIX}
-  $INSTALL_SH -c tools/mkpasswd${EXESUFFIX} ${DPATH}/mkpasswd${EXESUFFIX};
+if [ ! -f ${DPATH}mkpasswd ]; then
+  echo installing mkpasswd as ${DPATH}mkpasswd${EXESUFFIX}
+  $INSTALL_SH -c tools/mkpasswd${EXESUFFIX} ${DPATH}mkpasswd${EXESUFFIX};
 else
-   echo installing mkpasswd as ${DPATH}/mkpasswd${EXESUFFIX}
+   echo installing mkpasswd as ${DPATH}mkpasswd${EXESUFFIX}
    echo previous mkpasswd saved as mkpasswd${EXESUFFIX}.old
-   mv ${DPATH}/mkpasswd${EXESUFFIX} ${DPATH}/mkpasswd${EXESUFFIX}.old
-   $INSTALL_SH -c tools/mkpasswd${EXESUFFIX} ${DPATH}/mkpasswd${EXESUFFIX};
+   mv ${DPATH}mkpasswd${EXESUFFIX} ${DPATH}mkpasswd${EXESUFFIX}.old
+   $INSTALL_SH -c tools/mkpasswd${EXESUFFIX} ${DPATH}mkpasswd${EXESUFFIX};
 fi 
 
 # install viconf
-if [ ! -f ${DPATH}/viconf ]; then
-  echo installing viconf as ${DPATH}/viconf${EXESUFFIX}
-  $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}/viconf${EXESUFFIX};
+if [ ! -f ${DPATH}viconf ]; then
+  echo installing viconf as ${DPATH}viconf${EXESUFFIX}
+  $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX};
 else
-   echo installing viconf as ${DPATH}/viconf${EXESUFFIX}
+   echo installing viconf as ${DPATH}viconf${EXESUFFIX}
    echo previous viconf saved as viconf${EXESUFFIX}.old
-   mv ${DPATH}/viconf${EXESUFFIX} ${DPATH}/viconf${EXESUFFIX}.old
-   $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}/viconf${EXESUFFIX};
+   mv ${DPATH}viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX}.old
+   $INSTALL_SH -c tools/viconf${EXESUFFIX} ${DPATH}viconf${EXESUFFIX};
 fi
 
 # finished.