diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/config.h ircd-hybrid-6.0/include/config.h
--- ircd-hybrid-6.0.orig/include/config.h	Tue May 22 13:31:32 2001
+++ ircd-hybrid-6.0/include/config.h	Tue May 22 13:27:00 2001
@@ -51,8 +51,8 @@
  * system limits. If you know what you are doing, increase them now
  */
 
-#define HARD_FDLIMIT_   256
-#define INIT_MAXCLIENTS 200
+#define HARD_FDLIMIT_   4160 /* was 256 */
+#define INIT_MAXCLIENTS 4096 /* was 200 */
 
 #if defined(__CYGWIN__)
 #undef HARD_FDLIMIT_
@@ -107,16 +107,16 @@
  *
  */
 
-#define DPATH   "/usr/local/ircd/"
-#define SPATH   "/usr/local/ircd/ircd"
-#define CPATH   "ircd.conf"
-#define KPATH   "kline.conf"
-#define DLPATH  "kline.conf"
-#define MPATH   "ircd.motd"
-#define LPATH   "ircd.log"
-#define PPATH   "ircd.pid"
-#define HPATH   "opers.txt"
-#define OPATH   "opers.motd"
+#define DPATH   "./"
+#define SPATH   "./"
+#define CPATH   "etc/dancer-hybrid/ircd.conf"
+#define KPATH   "etc/dancer-hybrid/kline.conf"
+#define DLPATH  "etc/dancer-hybrid/dline.conf"
+#define MPATH   "etc/dancer-hybrid/motd"
+#define LPATH   "log/dancer-hybrid/ircd.log"
+#define PPATH   "run/ircd.pid"
+#define HPATH   "etc/dancer-hybrid/ohelp"
+#define OPATH   "etc/dancer-hybrid/omotd"
 
 /* HIDE_OPS
  * Define this to prevent non chanops from seeing what ops a channel has
@@ -130,7 +130,7 @@
  * TRACE and LTRACE, and prevents hunting by nickname for nonopers.
  * NOT ADEQUATELY TESTED YET, DON'T USE ON PRODUCTION NETWORK --Rodder
  */
-/* #undef SERVERHIDE */
+#define SERVERHIDE
 
 /* OPERHIDE
  * Define this to prevent non-operators from seeing that somebody is
@@ -141,12 +141,12 @@
 /* NETWORK_NAME
  * Displayed in place of the servername when SERVERHIDE is enabled
  */   
-#define NETWORK_NAME "EFnet"
+#define NETWORK_NAME "irc.openprojects.net"
 
 /* NETWORK_DESC
  * Displayed in place of the server info when SERVERHIDE is enabled
  */
-#define NETWORK_DESC "Eris Free Network"
+#define NETWORK_DESC "http://openprojects.nu/"
 
 /* USE_SERVICES
  * Defines whether or not you're using services on your network
@@ -185,8 +185,8 @@
  * implementation.  Once pre-hybrid5.2 servers are eradicated, we can drop this
  * down to 90 seconds or so. --Rodder
  */
-#define TS_MAX_DELTA 300        /* seconds */
-#define TS_WARN_DELTA 30        /* seconds */
+#define TS_MAX_DELTA 10        /* seconds */
+#define TS_WARN_DELTA 2        /* seconds */
 
 /* SLAVE_SERVERS - Use this to send LOCOPS and KLINES to servers you define
  * uses U: lines in ircd.conf, each server defined in an U: line
@@ -194,7 +194,7 @@
  * accept K-lines from those servers.
  * This is useful for sites with more than one client server.
  */
-#undef SLAVE_SERVERS
+#define SLAVE_SERVERS
 
 /* SEPARATE_QUOTE_KLINES_BY_DATE
  * If you define this, then klines will be read and written
@@ -214,8 +214,8 @@
  *
  * These need to be defined if you want to use SYSLOG logging, too.
  */
-#define FNAME_USERLOG "/usr/local/ircd/users" /* */
-#define FNAME_OPERLOG "/usr/local/ircd/opers" /* */
+#define FNAME_USERLOG "log/user.log" /* */
+#define FNAME_OPERLOG "log/oper.log" /* */
 
 /* SAVE_MAXCLIENT - store the max local and global client connections
  * into the file specified by MXPATH at the interval specified by 
@@ -239,12 +239,19 @@
  */
 #undef ALLOW_DOT_IN_IDENT
 
+/* INVEX
+ * Defining this will allow you to use the invite extention capab.
+ * This extension allows you to maintain a list of hostmasks which don't
+ * require an invite for +i channels.
+ */
+#define INVEX
+
 /* MAX_MULTI_MESSAGES
  * Maximum number of recipients to a PRIVMSG.  Any more than MAX_MULTI_MESSAGES
  * will not be sent.  If MAX_MULTI_MESSAGES is 1, then any PRIVMSG with a ',' in
  * the target will be rejected
  */
-#define MAX_MULTI_MESSAGES 2
+#define MAX_MULTI_MESSAGES 1
 
 /* NO_DUPE_MULTI_MESSAGES
  * Define this to check for duplicate recipients in PRIVMSG, at the expense
@@ -266,7 +273,7 @@
  * or if you wish to customize the  messages, define this.
  * Otherwise leave it undef'd for plain ole boring messages.
  */
-#undef CUSTOM_ERR
+#define CUSTOM_ERR
 
 /* FAILED_OPER_NOTICE - send a notice to all opers when someone
  * tries to /oper and uses an incorrect password.
@@ -276,7 +283,7 @@
 /* SHOW_FAILED_OPER_ID - if FAILED_OPER_NOTICE is defined, also notify when
  * a client fails to oper because of a identity mismatch (wrong host or nick)
  */
-#undef SHOW_FAILED_OPER_ID
+#define SHOW_FAILED_OPER_ID
 
 /* SHOW_FAILED_OPER_PASSWD - if FAILED_OPER_NOTICE is defined, also show the
  * attempted passwd
@@ -302,7 +309,7 @@
 #define ANTI_NICK_FLOOD
 /* defaults allow 5 nick changes in 20 seconds */
 #define MAX_NICK_TIME 20
-#define MAX_NICK_CHANGES 5 
+#define MAX_NICK_CHANGES 2
 
 /* DO_IDENTD - check identd
  * if you undefine this, ircd will never check identd regardless of
@@ -327,7 +334,7 @@
  * being KLINED very little difference, but you have been forewarned
  *
  */
-#define KLINE_WITH_REASON
+#undef KLINE_WITH_REASON
 
 /*
  * If KLINE_WITH_CONNECTION_CLOSED is defined and KLINE_WITH_REASON
@@ -336,7 +343,7 @@
  * from harassing the IRCops.
  * However, the client will still see the real reason upon connect attempts.
  */
-#define KLINE_WITH_CONNECTION_CLOSED
+#undef KLINE_WITH_CONNECTION_CLOSED
 
 /* NON_REDUNDANT_KLINES - If you want the server to flag and not apply
  * redundant klines
@@ -399,12 +406,12 @@
 /* NO_WHOIS_WILDCARDS - disable the use of wildcards in WHOIS.
  * this will probably be permanently enabled in the next release.
  */
-#define NO_WHOIS_WILDCARDS
+#undef NO_WHOIS_WILDCARDS
 
 /* PACE_WAIT - minimum seconds between use of MOTD, INFO, HELP, LINKS, TRACE
  * -Dianora
  */
-#define PACE_WAIT 10
+#define PACE_WAIT 5
 
 /* KNOCK_DELAY 5 minutes per each KNOCK should be enough
  */
@@ -413,8 +420,8 @@
 /* If you are an admin that does not think operwall/wallops
  * should be used instead of a channel, define this.
  */
-#define PACE_WALLOPS
-#define WALLOPS_WAIT 10 
+/* #define PACE_WALLOPS
+   #define WALLOPS_WAIT 5 */
 
 /* SHORT_MOTD
  * There are client ignoring the FORCE_MOTD MOTD numeric, there is
@@ -442,21 +449,21 @@
  * mode "i" (i == invisible). Invisibility means people dont showup in
  * WHO or NAMES unless they are on the same channel as you.
  */
-#undef  NO_DEFAULT_INVISIBLE
+#define NO_DEFAULT_INVISIBLE
 
 /*
  * The compression level used for zipped links. (Suggested values: 1 to 5)
  * Above 4 will only give a rather marginal increase in compression for a
  * large increase in CPU usage.
  */
-#define ZIP_LEVEL       2
+#define ZIP_LEVEL       4
 
 /*
  * OPER_UMODES LOCOP_UMODES - set these to be the initial umodes when OPER'ing
  * These can be over-ridden in ircd.conf file, with flags in last O field
  */
-#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL)
-#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE)
+#define OPER_UMODES   (FLAGS_OPER|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL|FLAGS_SKILL|FLAGS_BOTS)
+#define LOCOP_UMODES   (FLAGS_LOCOP|FLAGS_WALLOP|FLAGS_SERVNOTICE|FLAGS_OPERWALL|FLAGS_REJ|FLAGS_SKILL|FLAGS_BOTS|FLAGS_SPY)
 
 /* MAXIMUM LINKS - max links for class 0 if no Y: line configured
  *
@@ -493,7 +500,7 @@
  * to a leaf which just has 1 server (typically the uplink). Define this
  * correctly for performance reasons.
  */
-#undef  HUB
+#define  HUB
 
 /* CMDLINE_CONFIG - allow conf-file to be specified on command line
  * NOTE: defining CMDLINE_CONFIG and installing ircd SUID or SGID is a MAJOR
@@ -556,7 +563,7 @@
  * need not be the same for both, as long as the opposite end has the
  * right password in the opposite line.
  */
-#undef  CRYPT_LINK_PASSWORD
+#define  CRYPT_LINK_PASSWORD
 
 /* CRYPT_I_PASSWORD - use crypted I-line passwords in the ircd.conf
  * define this if you want to use crypted passwords for connecting users
@@ -594,7 +601,7 @@
  * send to the server without processing before disconnecting the client for
  * flooding it.  Values greater than 8000 make no difference to the server.
  */
-#define CLIENT_FLOOD    2560
+#define CLIENT_FLOOD    1500  /* was 2560 */
 
 /* NOISY_HTM - should HTM be noisy by default
  * should be YES or NO
@@ -620,7 +627,7 @@
  * if there are no servers presently connected to this server
  * opers are not affected. 
  */
-#undef NO_CHANOPS_WHEN_SPLIT
+#define NO_CHANOPS_WHEN_SPLIT
 
 /* 
  * NO_JOIN_ON_SPLIT_SIMPLE
@@ -664,7 +671,7 @@
  * number of users seen on net > SPLIT_SMALLNET_USER_SIZE start
  * counting down the SERVER_SPLIT_RECOVERY_TIME
  */
-#define SPLIT_SMALLNET_USER_SIZE 10000
+#define SPLIT_SMALLNET_USER_SIZE 1 /* was 10000 */
 
 /*
  * SPLIT_PONG will send a PING to a server after the connect burst.
@@ -712,7 +719,7 @@
  * beyond the idle limit
  */
 #undef  IDLE_CHECK
-#define IDLE_TIME 60
+#define IDLE_TIME 20160
 #define OPER_IDLE
 
 /* SEND_FAKE_KILL_TO_CLIENT - make the client think it's being /KILL'ed
@@ -818,7 +825,7 @@
  * Port where ircd resides. NOTE: This *MUST* be greater than 1024 if you
  * plan to run ircd under any other uid than root.
  */
-#define PORTNUM 6667
+#define PORTNUM 8007
 
 /* MAXCONNECTIONS - don't touch - change the HARD_FDLIMIT_ instead
  * Maximum number of network connections your server will allow.  This should
@@ -851,7 +858,7 @@
  * If the connection to to uphost is down, then attempt to reconnect every 
  * CONNECTFREQUENCY  seconds.
  */
-#define CONNECTFREQUENCY 600    /* Recommended value: 600 */
+#define CONNECTFREQUENCY 60     /* Recommended value: 600 */
 
 /* HANGONGOODLINK and HANGONGOODLINK
  * Often net breaks for a short time and it's useful to try to
@@ -889,7 +896,7 @@
 /* MAXCHANNELSPERUSER -
  * Max number of channels a user is allowed to join.
  */
-#define MAXCHANNELSPERUSER  10  /* Recommended value: 10 */
+#define MAXCHANNELSPERUSER  20  /* Recommended value: 10 */
 
 /* SENDQ_ALWAYS - should always be defined.
  * SendQ-Always causes the server to put all outbound data into the sendq and
@@ -929,7 +936,7 @@
 /* JUPE_CHANNEL - jupes a channel from being joined on this server only
  * if added to Q lines e.g. Q:\#packet_channel:Tired of packets
  */
-#undef JUPE_CHANNEL
+#define JUPE_CHANNEL
 
 /* 
  * ANTI_SPAMBOT
@@ -958,7 +965,7 @@
  *
  */
 #define MIN_JOIN_LEAVE_TIME  60
-#define MAX_JOIN_LEAVE_COUNT  25
+#define MAX_JOIN_LEAVE_COUNT  15 /* was 25 */
 #define OPER_SPAM_COUNTDOWN   5 
 #define JOIN_LEAVE_COUNT_EXPIRE_TIME 120
 
@@ -980,14 +987,14 @@
  * (idea due to ThaDragon, I just couldn't find =his= code)
  * - Dianora
  */
-#undef ANTI_SPAM_EXIT_MESSAGE
+#define ANTI_SPAM_EXIT_MESSAGE
 /* 300 is five minutes, seems reasonable */
 #define ANTI_SPAM_EXIT_MESSAGE_TIME 300
 
 #ifdef FLUD
-#define FLUD_NUM        4       /* Number of flud messages to trip alarm */
-#define FLUD_TIME       3       /* Seconds in which FLUD_NUM msgs must occur */
-#define FLUD_BLOCK      15      /* Seconds to block fluds */
+#define FLUD_NUM        2       /* Number of flud messages to trip alarm */
+#define FLUD_TIME       5       /* Seconds in which FLUD_NUM msgs must occur */
+#define FLUD_BLOCK      20      /* Seconds to block fluds */
 #endif
 
 /* REJECT_HOLD 
@@ -1047,8 +1054,8 @@
  * three different servers must do the identical GLINE in order
  * for the G line to take effect.
  */
-#undef GLINES
-#define GLINEFILE       "gline.log"
+#define GLINES
+#define GLINEFILE       "log/gline.log"
 
 /* GLINE_TIME - local expire time for GLINES
  * As configured here, a GLINE will last 12 hours
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/ircd_defs.h ircd-hybrid-6.0/include/ircd_defs.h
--- ircd-hybrid-6.0.orig/include/ircd_defs.h	Tue May 22 13:31:31 2001
+++ ircd-hybrid-6.0/include/ircd_defs.h	Tue May 22 13:26:59 2001
@@ -35,16 +35,16 @@
 #define HOSTLEN         63      /* Length of hostname.  Updated to         */
                                 /* comply with RFC1123                     */
 
-#define NICKLEN         9       /* Necessary to put 9 here instead of 10
+#define NICKLEN         30      /* Necessary to put 9 here instead of 10
                                  * if s_msg.c/m_nick has been corrected.
                                  * This preserves compatibility with old
                                  * servers --msa
                                  */
 #define USERLEN         10
 #define REALLEN         50
-#define TOPICLEN        120     /* old value 90, truncated on other servers */
+#define TOPICLEN        450     /* old value 90, truncated on other servers */
 #define KILLLEN         90      
-#define CHANNELLEN      200
+#define CHANNELLEN      30
 #define KEYLEN          23
 #define BUFSIZE         512     /* WARNING: *DONT* CHANGE THIS!!!! */
 #define MAXRECIPIENTS   20
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/include/patchlevel.h ircd-hybrid-6.0/include/patchlevel.h
--- ircd-hybrid-6.0.orig/include/patchlevel.h	Thu Jan  4 03:14:27 2001
+++ ircd-hybrid-6.0/include/patchlevel.h	Tue May 22 13:26:57 2001
@@ -17,5 +17,5 @@
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL    "2.8/hybrid-6.0"
+#define PATCHLEVEL    "2.8/dancer-hybrid-6.0"
 #endif
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/client.c ircd-hybrid-6.0/src/client.c
--- ircd-hybrid-6.0.orig/src/client.c	Tue May 22 13:31:31 2001
+++ ircd-hybrid-6.0/src/client.c	Tue May 22 13:26:59 2001
@@ -1605,8 +1605,8 @@
 
       if (sptr->servptr == &me)
         {
-          sendto_ops("%s was connected for %d seconds.  %d/%d sendK/recvK.",
-                     sptr->name, CurrentTime - sptr->firsttime,
+          sendto_ops_flags_butone(NULL, FLAGS_SERVNOTICE, "%s was connected to %s for %d seconds.  %d/%d sendK/recvK.",
+                     sptr->name, &me.name, CurrentTime - sptr->firsttime,
                      sptr->sendK, sptr->receiveK);
           log(L_NOTICE, "%s was connected for %d seconds.  %d/%d sendK/recvK.",
               sptr->name, CurrentTime - sptr->firsttime, 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_message.c ircd-hybrid-6.0/src/m_message.c
--- ircd-hybrid-6.0.orig/src/m_message.c	Tue May 22 13:31:32 2001
+++ ircd-hybrid-6.0/src/m_message.c	Tue May 22 13:27:00 2001
@@ -448,7 +448,7 @@
   **
   ** Armin, 8Jun90 (gruner@informatik.tu-muenchen.de)
   */
-  if ((*nick == '$' || *nick == '#'))
+  if ((*nick == '$' || *nick == '>'))
     {
 
       if(!IsAnOper(sptr))
@@ -480,7 +480,7 @@
         
       sendto_match_butone(IsServer(cptr) ? cptr : NULL, 
                           sptr, nick + 1,
-                          (*nick == '#') ? MATCH_HOST :
+                          (*nick == '>') ? MATCH_HOST :
                           MATCH_SERVER,
                           ":%s %s %s :%s", parv[0],
                           cmd, nick, parv[2]);
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/m_set.c ircd-hybrid-6.0/src/m_set.c
--- ircd-hybrid-6.0.orig/src/m_set.c	Tue May 22 13:31:29 2001
+++ ircd-hybrid-6.0/src/m_set.c	Tue May 22 13:26:58 2001
@@ -469,12 +469,12 @@
             {
               int newval = atoi(parv[2]);
 
-              if(newval < SPLIT_SMALLNET_SIZE)
+/*              if(newval < SPLIT_SMALLNET_SIZE)
                 {
                   sendto_one(sptr, ":%s NOTICE %s :SPLITNUM must be >= %d",
                              me.name, parv[0],SPLIT_SMALLNET_SIZE);
                   return 0;
-                }
+                } */
               sendto_realops("%s has changed SPLITNUM to %i",
                              parv[0], newval);
               SPLITNUM = newval;
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/motd.c ircd-hybrid-6.0/src/motd.c
--- ircd-hybrid-6.0.orig/src/motd.c	Wed Aug 25 23:58:22 1999
+++ ircd-hybrid-6.0/src/motd.c	Tue May 22 13:26:57 2001
@@ -192,10 +192,10 @@
 
   if (local_tm)
     ircsprintf(MessageFileptr->lastChangedDate,
-               "%d/%d/%d %t:%t",
-               local_tm->tm_mday,
-               local_tm->tm_mon + 1,
+               "%d-%d-%d %t:%t",
                1900 + local_tm->tm_year,
+               local_tm->tm_mon + 1,
+               local_tm->tm_mday,
                local_tm->tm_hour,
                local_tm->tm_min);
 
diff -ruN -x configure -x *~ -x ircd-hybrid-6.0.orig -x *.rej ircd-hybrid-6.0.orig/src/res.c ircd-hybrid-6.0/src/res.c
--- ircd-hybrid-6.0.orig/src/res.c	Tue May 22 13:31:30 2001
+++ ircd-hybrid-6.0/src/res.c	Tue May 22 13:26:58 2001
@@ -449,9 +449,9 @@
   memset(request, 0, sizeof(ResRQ));
 
   request->sentat  = CurrentTime;
-  request->retries = 3;
+  request->retries = 2;
   request->resend  = 1;
-  request->timeout = 4;    /* start at 4 and exponential inc. */
+  request->timeout = 2;    /* start at 2 and exponential inc. */
   request->addr.s_addr      = INADDR_NONE;
   request->he.h.h_addrtype  = AF_INET;
   request->he.h.h_length    = sizeof(struct in_addr);