diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/include/m_commands.h ircd-hybrid-6b124/include/m_commands.h
--- ircd-hybrid-6b124.orig/include/m_commands.h	Sun Apr 23 03:52:27 2000
+++ ircd-hybrid-6b124/include/m_commands.h	Sun Apr 23 03:51:56 2000
@@ -101,5 +101,6 @@
 extern int m_sethost(struct Client *,struct Client *,int,char **);
 extern int m_setident(struct Client *,struct Client *,int,char **);
 extern int m_setname(struct Client *,struct Client *,int,char **);
+extern int m_makepass(struct Client *,struct Client *,int,char **);
 
 #endif /* INCLUDED_m_commands_h */
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/include/msg.h ircd-hybrid-6b124/include/msg.h
--- ircd-hybrid-6b124.orig/include/msg.h	Sun Apr 23 03:52:27 2000
+++ ircd-hybrid-6b124/include/msg.h	Sun Apr 23 03:51:56 2000
@@ -124,6 +124,7 @@
 #define MSG_SETHOST  "SETHOST"  /* SETHOST */
 #define MSG_SETIDENT "SETIDENT" /* SETIDENT */
 #define MSG_SETNAME  "SETNAME"  /* SETNAME */
+#define MSG_MAKEPASS "MAKEPASS" /* MAKEPASS */
 
 #define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
 #ifdef LWALLOPS
@@ -255,6 +256,7 @@
   { MSG_SETHOST, m_sethost,  0, 2,       1, 0, 0, 0L },
   { MSG_SETIDENT, m_setident,0, 2,       1, 0, 0, 0L },
   { MSG_SETNAME, m_setname,  0, 2, 1, 0, 0, 0L },
+  { MSG_MAKEPASS,m_makepass, 0, 2,       1, 0, 0, 0L },
 
   { (char *) 0, (int (*)()) 0 , 0, 0,    0, 0, 0, 0L }
 };
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/Makefile.in ircd-hybrid-6b124/src/Makefile.in
--- ircd-hybrid-6b124.orig/src/Makefile.in	Sun Apr 23 03:52:27 2000
+++ ircd-hybrid-6b124/src/Makefile.in	Sun Apr 23 03:51:56 2000
@@ -54,6 +54,7 @@
 	m_locops.c \
 	m_ltrace.c \
 	m_lusers.c \
+	m_makepass.c \
 	m_message.c \
 	m_mode.c \
 	m_operwall.c \
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/m_makepass.c ircd-hybrid-6b124/src/m_makepass.c
--- ircd-hybrid-6b124.orig/src/m_makepass.c	Wed Dec 31 18:00:00 1969
+++ ircd-hybrid-6b124/src/m_makepass.c	Sun Apr 23 03:52:15 2000
@@ -0,0 +1,151 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_makepass.c
+ *
+ *   Written for UltimateIRCd by ShadowRealm Creations.
+ *   Copyright (C) 1997-2000 Infomedia Inc.
+ *
+ *   Adapted to ircd-hybrid by Johnie Ingram (netgod) for Open Projects.
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+#include "common.h"
+#include "assert.h"
+#include "m_commands.h"
+#include "client.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "send.h"
+#include "channel.h"
+#include "irc_string.h"
+#include "s_debug.h"
+
+/*
+ * m_functions execute protocol messages on this server:
+ *
+ *      cptr    is always NON-NULL, pointing to a *LOCAL* client
+ *              structure (with an open socket connected!). This
+ *              identifies the physical socket where the message
+ *              originated (or which caused the m_function to be
+ *              executed--some m_functions may call others...).
+ *
+ *      sptr    is the source of the message, defined by the
+ *              prefix part of the message if present. If not
+ *              or prefix not found, then sptr==cptr.
+ *
+ *              (!IsServer(cptr)) => (cptr == sptr), because
+ *              prefixes are taken *only* from servers...
+ *
+ *              (IsServer(cptr))
+ *                      (sptr == cptr) => the message didn't
+ *                      have the prefix.
+ *
+ *                      (sptr != cptr && IsServer(sptr) means
+ *                      the prefix specified servername. (?)
+ *
+ *                      (sptr != cptr && !IsServer(sptr) means
+ *                      that message originated from a remote
+ *                      user (not local).
+ *
+ *              combining
+ *
+ *              (!IsServer(sptr)) means that, sptr can safely
+ *              taken as defining the target structure of the
+ *              message in this server.
+ *
+ *      *Always* true (if 'parse' and others are working correct):
+ *
+ *      1)      sptr->from == cptr  (note: cptr->from == cptr)
+ *
+ *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
+ *              *cannot* be a local connection, unless it's
+ *              actually cptr!). [MyConnect(x) should probably
+ *              be defined as (x == x->from) --msa ]
+ *
+ *      parc    number of variable parameter strings (if zero,
+ *              parv is allowed to be NULL)
+ *
+ *      parv    a NULL terminated list of parameter pointers,
+ *
+ *                      parv[0], sender (prefix string), if not present
+ *                              this points to an empty string.
+ *                      parv[1]...parv[parc-1]
+ *                              pointers to additional parameters
+ *                      parv[parc] == NULL, *always*
+ *
+ *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
+ *                      non-NULL pointers.
+ */
+
+/*
+** m_makepass
+**      parv[0] = sender prefix
+**      parv[1] = passphrase to encrypt
+*/
+int m_makepass(struct Client *cptr,
+               struct Client *sptr,
+               int parc,
+               char *parv[])
+{
+  static char saltChars[] = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
+  static time_t   last_used = 0;
+  char salt[9];
+  extern char *libshadow_md5_crypt();
+
+  if(!IsClient(sptr))
+    {
+      return 0;
+    }
+
+  if(!IsAnOper(sptr))
+    {
+      if((last_used + PACE_WAIT) > CurrentTime)
+        {
+          /* safe enough to give this on a local connect only */
+          if(MyClient(sptr))
+            sendto_one(sptr,form_str(RPL_LOAD2HI),me.name,parv[0]);
+          return 0;
+        }
+      else
+        {
+          last_used = CurrentTime;
+        }
+    }
+
+  if (parc < 2 || *parv[1] == '\0')
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "MAKEPASS");
+      return 0;
+    }
+
+  srandom(CurrentTime);
+  salt[0] = saltChars[random() % 64];
+  salt[1] = saltChars[random() % 64];
+  salt[2] = saltChars[random() % 64];
+  salt[3] = saltChars[random() % 64];
+  salt[4] = saltChars[random() % 64];
+  salt[5] = saltChars[random() % 64];
+  salt[6] = saltChars[random() % 64];
+  salt[7] = saltChars[random() % 64];
+  salt[8] = 0;
+
+  sendto_one(sptr, ":%s NOTICE %s :*** Encryption for [ %s ] is [ %s ]",
+             me.name, parv[0], parv[1], libshadow_md5_crypt(parv[1], salt));
+  return 0;
+}