diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/include/m_commands.h ircd-hybrid-6b124/include/m_commands.h
--- ircd-hybrid-6b124.orig/include/m_commands.h	Thu Apr 27 04:51:27 2000
+++ ircd-hybrid-6b124/include/m_commands.h	Thu Apr 27 03:45:56 2000
@@ -102,5 +102,6 @@
 extern int m_setident(struct Client *,struct Client *,int,char **);
 extern int m_setname(struct Client *,struct Client *,int,char **);
 extern int m_makepass(struct Client *,struct Client *,int,char **);
+extern int m_stopic(struct Client *,struct Client *,int,char **);
 
 #endif /* INCLUDED_m_commands_h */
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/include/msg.h ircd-hybrid-6b124/include/msg.h
--- ircd-hybrid-6b124.orig/include/msg.h	Thu Apr 27 04:51:27 2000
+++ ircd-hybrid-6b124/include/msg.h	Thu Apr 27 03:44:30 2000
@@ -125,6 +125,7 @@
 #define MSG_SETIDENT "SETIDENT" /* SETIDENT */
 #define MSG_SETNAME  "SETNAME"  /* SETNAME */
 #define MSG_MAKEPASS "MAKEPASS" /* MAKEPASS */
+#define MSG_STOPIC   "STOPIC"   /* STOPIC */
 
 #define MSG_LOCOPS   "LOCOPS"   /* LOCOPS */
 #ifdef LWALLOPS
@@ -257,6 +258,7 @@
   { MSG_SETIDENT, m_setident,0, 2,       1, 0, 0, 0L },
   { MSG_SETNAME, m_setname,  0, MAXPARA, 1, 0, 0, 0L },
   { MSG_MAKEPASS,m_makepass, 0, 2,       1, 0, 0, 0L },
+  { MSG_STOPIC,  m_stopic,   0, MAXPARA, 1, 0, 0, 0L },
 
   { (char *) 0, (int (*)()) 0 , 0, 0,    0, 0, 0, 0L }
 };
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/Makefile.in ircd-hybrid-6b124/src/Makefile.in
--- ircd-hybrid-6b124.orig/src/Makefile.in	Thu Apr 27 04:51:27 2000
+++ ircd-hybrid-6b124/src/Makefile.in	Thu Apr 27 03:39:35 2000
@@ -70,6 +70,7 @@
 	m_setname.c \
 	m_squit.c \
 	m_stats.c \
+	m_stopic.c \
 	m_svinfo.c \
 	m_time.c \
 	m_trace.c \
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/m_stopic.c ircd-hybrid-6b124/src/m_stopic.c
--- ircd-hybrid-6b124.orig/src/m_stopic.c	Wed Dec 31 18:00:00 1969
+++ ircd-hybrid-6b124/src/m_stopic.c	Thu Apr 27 04:51:11 2000
@@ -0,0 +1,145 @@
+/************************************************************************
+ *   IRC - Internet Relay Chat, src/m_stopic.c
+ *   Copyright (C) 1990 Jarkko Oikarinen and
+ *                      University of Oulu, Computing Center
+ *
+ *   Written by Johnie Ingram (netgod) for Open Projects.
+ *
+ *   See file AUTHORS in IRC package for additional names of
+ *   the programmers. 
+ *
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License as published by
+ *   the Free Software Foundation; either version 1, or (at your option)
+ *   any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ *   
+ */
+
+#include "m_commands.h"
+#include "client.h"
+#include "channel.h"
+#include "hash.h"
+#include "struct.h"
+#include "ircd.h"
+#include "numeric.h"
+#include "s_serv.h"
+#include "send.h"
+#include "list.h"
+#include "irc_string.h"
+
+/*
+ * m_functions execute protocol messages on this server:
+ *
+ *      cptr    is always NON-NULL, pointing to a *LOCAL* client
+ *              structure (with an open socket connected!). This
+ *              identifies the physical socket where the message
+ *              originated (or which caused the m_function to be
+ *              executed--some m_functions may call others...).
+ *
+ *      sptr    is the source of the message, defined by the
+ *              prefix part of the message if present. If not
+ *              or prefix not found, then sptr==cptr.
+ *
+ *              (!IsServer(cptr)) => (cptr == sptr), because
+ *              prefixes are taken *only* from servers...
+ *
+ *              (IsServer(cptr))
+ *                      (sptr == cptr) => the message didn't
+ *                      have the prefix.
+ *
+ *                      (sptr != cptr && IsServer(sptr) means
+ *                      the prefix specified servername. (?)
+ *
+ *                      (sptr != cptr && !IsServer(sptr) means
+ *                      that message originated from a remote
+ *                      user (not local).
+ *
+ *              combining
+ *
+ *              (!IsServer(sptr)) means that, sptr can safely
+ *              taken as defining the target structure of the
+ *              message in this server.
+ *
+ *      *Always* true (if 'parse' and others are working correct):
+ *
+ *      1)      sptr->from == cptr  (note: cptr->from == cptr)
+ *
+ *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
+ *              *cannot* be a local connection, unless it's
+ *              actually cptr!). [MyConnect(x) should probably
+ *              be defined as (x == x->from) --msa ]
+ *
+ *      parc    number of variable parameter strings (if zero,
+ *              parv is allowed to be NULL)
+ *
+ *      parv    a NULL terminated list of parameter pointers,
+ *
+ *                      parv[0], sender (prefix string), if not present
+ *                              this points to an empty string.
+ *                      parv[1]...parv[parc-1]
+ *                              pointers to additional parameters
+ *                      parv[parc] == NULL, *always*
+ *
+ *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
+ *                      non-NULL pointers.
+ */
+
+
+
+/*
+** m_stopic
+**      parv[0] = sender prefix
+**      parv[1] = channel name
+**      parv[2] = topic nick
+**      parv[3] = topic time
+**      parv[4] = topic text
+*/
+
+int     m_stopic(struct Client *cptr,
+                struct Client *sptr,
+                int parc,
+                char *parv[])
+{
+  struct Channel *chptr = NullChn;
+  char  *topic = (char *)NULL, *name, *p = (char *)NULL;
+  
+  if (parc < 5)
+    {
+      sendto_one(sptr, form_str(ERR_NEEDMOREPARAMS),
+                 me.name, parv[0], "STOPIC");
+      return 0;
+    }
+  if (!IsPrivileged(sptr))
+    {
+      sendto_one(sptr, form_str(ERR_NOPRIVILEGES), me.name, parv[0]);
+      return(0);
+    }
+#ifdef TOPIC_INFO
+  if (chptr = hash_find_channel(parv[1], NullChn))
+    {
+      time_t topic_time = atoi(parv[3]);
+      if (!topic_time || topic_time > chptr->topic_time)
+        {
+          chptr->topic_time = (topic_time) ? topic_time : CurrentTime;
+          strncpy_irc(chptr->topic_nick, parv[2], NICKLEN);
+          strncpy_irc(chptr->topic, parv[4], TOPICLEN);
+          sendto_channel_butserv(chptr, sptr, ":%s TOPIC %s :%s",
+                                 parv[0],
+                                 chptr->chname, chptr->topic);
+        }
+    }
+#endif
+  sendto_serv_butone(cptr,":%s STOPIC %s %s %s :%s",
+                     parv[0], parv[1], parv[2], parv[3], parv[4]);
+  return 0;
+}
diff -ruN -x configure -x *~ -x ircd-hybrid-6b124.orig -x *.rej ircd-hybrid-6b124.orig/src/s_serv.c ircd-hybrid-6b124/src/s_serv.c
--- ircd-hybrid-6b124.orig/src/s_serv.c	Thu Apr 27 04:51:27 2000
+++ ircd-hybrid-6b124/src/s_serv.c	Thu Apr 27 04:48:37 2000
@@ -806,6 +806,12 @@
         if(chptr->users != 0)
 #endif
           send_channel_modes(cptr, chptr);
+#ifdef TOPIC_INFO
+        if (chptr->topic_time)
+          sendto_one(cptr,":%s STOPIC %s %s %i :%s",
+                     me.name, chptr->chname, chptr->topic_nick,
+                     chptr->topic_time, chptr->topic);
+#endif
       }
     /*
     ** also send out those that are not on any channel